function CRLB = DSFLocUknPropSpdStnySrc_CRLB(p,s,s_dot,f0,c,Qe)
% function CRLB = DSFLocUknPropSpdStnySrc_CRLB(p,s,s_dot,f0,c,Qe)
%
% CRLB for stationary object localization using frequency measurements when
% signal propagation speed is not known.
%
% Reference:
% D. Lin, G. Wang, K. C. Ho, and L. Huang, "Source localization by frequency
% measurements in unknown signal propagation speed environments," IEEE
% Trans. Aerosp. Electron. Syst., vol. 59, no. 4, pp. 3953-3970, Aug. 2023.
%
% Danyan Lin, Gang Wang, K. C. Ho	Nov. 1, 2023
%
%       Copyright (C) 2023
%       the Faculty of Electrical Engineering and Computer Science
%       Ningbo University
%       Ningbo 315211, China
%       wanggang@nbu.edu.cn
%

warning('off');
N = size(s,2);
I = eye(2,2);
a = zeros(N,2);
% b = zeros(N,2);
de_c = zeros(N,1);
de_fo = zeros(N,1);


for i=1:N
    a(i,:) = -f0/c*s_dot(:,i)'/(norm(p-s(:,i)))*(I-(p-s(:,i))*(p-s(:,i))'/(norm(p-s(:,i))^2));
%     b(i,:) = f0/c*(p-s(:,i))'/norm(p-s(:,i));
    de_c(i,:) = f0/c^2*(p-s(:,i))'*s_dot(:,i)/norm(p-s(:,i));
%     de_fo(i) = 1+(p-s(:,i))'*s_dot(:,i)/c/norm(p-s(:,i));
end

f_theta = [a de_c];
X=f_theta'/Qe*f_theta;
% Y=f_theta'/Qe*de_fo;
% Z=de_fo'/Qe*de_fo+inv(Qf0);

CRLB= diag(inv(X));





